from engine.pyEng  import *
from ent           import *
from bullet        import *
from explosion     import *
from math          import *
from shieldPower   import *
import pygame
import random

droneTri = []

def buildDrone():
    droneLenth = 7.0, 7.0, 25.0
    droneRot   = 45.0, -45.0, 0.0
    
    for i in range(361):
        drone  = []
        rot    = i * (pi/180)
        
        tri = []
        for j in range(3):
            x = droneLenth[j] * cos(rot + droneRot[j])
            y = droneLenth[j] * sin(rot + droneRot[j])
            tri.append([x, y])
        drone.append(tri)
        
        droneTri.append(drone)

buildDrone()

class Drone1(Ent):
    
    def __init__(self):
        Ent.__init__(self, engine.getId())
        
        self.name      = "DRONE1_" + str(self.id)
        self.pos.x     = 500
        self.pos.y     = 500
        self.rot       = math.pi/2
        self.maxSpeed  = engine.globalVar['drone1Speed'] + (0.2 - (0.4 * random.random()))
        self.desSpeed  = self.maxSpeed
        self.acel      = 0.025
        self.rcel      = 0.025 + (0.0025 - (0.005 * random.random()))
        self.color     = [255, 0, 0]
        self.z         = 10
        self.fireDist  = 20
        self.fireCount = 5
        self.fireDir   = 0
        self.fireTime  = 0
        self.fireRate  = 0.1
        self.radius    = 15
        
    def tick (self, time, dtime):
        p = engine.get('PLAYER_0')
        
        self.desRot = math.atan2(p.pos.y - self.pos.y, p.pos.x - self.pos.x)
        
        fireX = self.pos.x
        fireY = self.pos.y
        for i in range(self.fireCount):
            
            dir   = 2 * pi * random.random()
            dist1 = 10 * random.random()
            dist2 = 4  * random.random()

            x  = fireX  + (self.fireDist * cos(self.rot+math.pi))
            y  = fireY  + (self.fireDist * sin(self.rot+math.pi))
            x += dist1  * cos(self.rot+self.fireDir)
            y += dist1  * sin(self.rot+self.fireDir)
            x += dist2  * cos(dir)
            y += dist2  * sin(dir)
            size  = 10  * random.random()
            color = 255 * random.random()
            self.screen.drawCircle([x, y], size, [255, color, 0], self.z)
        
        self.move()
        self.checkCollisions()
        self.drawEntity()

    def collided(self, e):
        if(e.name.find("BULLET") > -1):
            e.dead    = True
            self.die()
            
    def die(self):
        self.dead = True
        t = engine.get('TARGET_COUNTER')
        t.targetCount -= 1
        p = engine.get('PLAYER_0')
        p.hitTarget(1)
        x = Explosion()
        x.pos.x = self.pos.x
        x.pos.y = self.pos.y
        engine.add(x)
        self.sound.play('sExp')
        
        if(random.random() < 0.05):
            x           = ShieldPower()
            x.pos.x     = self.pos.x
            x.pos.y     = self.pos.y
            x.startTime = engine.t
            engine.add(x)
            
    def drawEntity(self):
        self.screen.drawCircle(self.pos.val(), 9, self.color, self.z+1)
        self.screen.drawCircle(self.pos.val(), 7, [0,0,0],    self.z+2)
        
        r = self.rot
        while(r > pi):
            r -= 2 * pi
        while(r < -pi):
            r += 2 * pi
        r = int(r * (180.0/math.pi))
        
        for i in droneTri[r]:
            p = []
            for j in i:
                p.append([j[0]+self.pos.x, j[1]+self.pos.y])
            self.screen.drawPoly(p, self.color, self.z+3)