from device import *
import pygame
import pygame.joystick

pygame.joystick.init()

class GamepadDevice(Device):
    
    def __init__(self, id):
        Device.__init__(self)
        
        self.name = "Gamepad_" + str(id)
        if(pygame.joystick.get_count() > 0):
            self.joy = pygame.joystick.Joystick(id)
            self.joy.init()
            
            print " ---- INIT GAMEPAD ---- "
            print "   -- Buttons " + str(self.joy.get_numbuttons())
            print "   -- Axes " + str(self.joy.get_numaxes())
        else:
            self.joy = False
            
            print " ---- INIT GAMEPAD ---- "
            print "   -- No gamepad found"
            
        self.XaxisMax = [-10, -10]
        self.XaxisMin = [ 10,  10]
        self.YaxisMax = [-10, -10]
        self.YaxisMin = [ 10,  10]
    
    def numButtons(self):
        if(self.joy):
            return self.joy.get_numbuttons()
        else:
            return 0
        
    def button(self, id):
        if(self.joy):
            return self.joy.get_button(id)
        else:
            return False
    
    def xAxis(self, id = 0):
        if(self.joy):        
            val = self.joy.get_axis(id*2)
            if(val > self.XaxisMax[id]):
                self.XaxisMax[id] = val
            if(val < self.XaxisMin[id]):
                self.XaxisMin[id] = val
    
            div = (self.XaxisMax[id] - self.XaxisMin[id])
            if(div == 0):
                div = 0.0001
                
            val = (val-self.XaxisMin[id])/div
            return (2*val)-1
        else:
            return 0
    
    def yAxis(self, id = 0):
        if(self.joy):        
            val = self.joy.get_axis((id*2)+1)
            if(val > self.YaxisMax[id]):
                self.YaxisMax[id] = val
            if(val < self.YaxisMin[id]):
                self.YaxisMin[id] = val
            
            div = (self.YaxisMax[id] - self.YaxisMin[id])
            if(div == 0):
                div = 0.0001
                
            val = (val-self.YaxisMin[id])/div
            return (2*val)-1
        else:
            return 0