from v2 import *
import math

class Obb():
    
    def __init__(self):
        self.pos      = V2()
        self.width    = 0
        self.height   = 0
        self.rotation = 0
        
    def xNormal(self):
        v = V2()
        v.x = math.cos(-self.rotation)
        v.y = math.sin(-self.rotation)
        return v
    
    def yNormal(self):
        v = V2()
        v.x = math.cos(-self.rotation + (math.pi/2))
        v.y = math.sin(-self.rotation + (math.pi/2))
        return v
    
    def getProjectedRadius(self, box, normal):
        return ((box.width * abs(normal * box.xNormal())) + (box.height * abs(normal * box.yNormal()))) / 2
    
    def separatedOnAxis(self, box, normal):
        val = False

        v = V2()
        v.x = self.pos.x - box.pos.x
        v.y = self.pos.y - box.pos.y
        r = abs(v * normal)
        if ((self.getProjectedRadius(self, normal) + self.getProjectedRadius(box, normal)) < r):
            val = True
            
        return val
        
    def checkCollision(self, obb):
        collision = True
        
        if(self.separatedOnAxis(obb, self.xNormal())):
            collision = False
        elif(self.separatedOnAxis(obb, self.yNormal())):
            collision = False
        elif(self.separatedOnAxis(obb, obb.xNormal())):
            collision = False
        elif(self.separatedOnAxis(obb, obb.yNormal())):
            collision = False
        
        return collision