import pygame
from pygame.locals import *

pygame.init()

class PyEng():
    
    def __init__(self):
        self.gameObjects = {}
        self.globalVar   = {}
        self.clock       = pygame.time.Clock()
        self.t           = 0
        self.dt          = 0
        self.maxFrames   = 60
        self.id          = 0
        self.stop        = False
        self.keyPressed  = False
        self.keys        = []
        self.shift       = False
        self.left        = False
        self.right       = False
        self.enter       = False
        self.register    = True
        print " ---- INIT ENIGINE ----"
        
    def tick(self):
        t       = float(self.clock.tick(self.maxFrames))/1000
        self.t += t
        self.dt = t
        
        self.keyPressed = False
        self.keys       = []
        self.left       = False
        self.right      = False
        self.enter      = False
        for event in pygame.event.get():
            
            self.register = True
            if(event.type == KEYDOWN):
                name = pygame.key.name(event.key)
                
                if((name == 'left') or (name == 'backspace')):
                    self.left     = True
                    self.register = False
                    
                if(name =='right'):
                    self.right = True
                    self.register = False
                    
                if(name == 'return'):
                    self.enter = True
                    self.register = False
                    
                if((name == 'left shift') or (name == 'right shift')):
                    self.shift = True
                    self.register = False
                    
                if(self.register):
                    self.keyPressed = True
                    if(self.shift):
                        if(name == '`'):
                            self.keys.append('~')
                        elif(name == '1'):
                            self.keys.append('!')
                        elif(name == '2'):
                            self.keys.append('@')
                        elif(name == '3'):
                            self.keys.append('#')
                        elif(name == '4'):
                            self.keys.append('$')
                        elif(name == '5'):
                            self.keys.append('%')
                        elif(name == '6'):
                            self.keys.append('^')
                        elif(name == '7'):
                            self.keys.append('&')
                        elif(name == '8'):
                            self.keys.append('*')
                        elif(name == '9'):
                            self.keys.append('(')
                        elif(name == '0'):
                            self.keys.append(')')
                        elif(name == '-'):
                            self.keys.append('_')
                        elif(name == '='):
                            self.keys.append('+')
                        elif(name == '['):
                            self.keys.append('{')
                        elif(name == ']'):
                            self.keys.append('}')
                        elif(name == '\\'):
                            self.keys.append('|')
                        elif(name == ';'):
                            self.keys.append(':')
                        elif(name == "'"):
                            self.keys.append('"')
                        elif(name == ','):
                            self.keys.append('<')
                        elif(name == '.'):
                            self.keys.append('>')
                        elif(name == '/'):
                            self.keys.append('?')
                        else:
                            self.keys.append(name.upper())
                    else:
                        self.keys.append(name)
            if(event.type == KEYUP):
                name = pygame.key.name(event.key)
                if((name == 'left shift') or (name == 'right shift')):
                    self.shift = False
        
        #print self.clock.get_fps()
        
        for key, value in self.gameObjects.items():
            pass
            if(value.dead):
                self.gameObjects.pop(key)
            else:
                value.tick(self.t, self.dt)
                
    def add(self, gameObject):
        self.gameObjects[gameObject.name] = gameObject
        
    def get(self, gameObject):
        return self.gameObjects[gameObject]
        
    def list(self):
        for key, value in self.gameObjects.items():
            print key
            
    def getId(self):
        self.id += 1
        return self.id
    
    def clear(self):
        self.gameObjects = {}
        self.globalVar   = {}
            
engine = PyEng()