from engine.pyEng import *
from device       import *
import pygame

pygame.mixer.quit()
pygame.mixer.init(22050, 8, 2, 1024)

class SoundDevice(Device):
    
    def __init__(self):
        Device.__init__(self)
        
        self.name   = "SoundDevice"
        self.sounds = {}
        self.queue  = {}
        self.total  = 0
        
    def add(self, name, path, channels = 1):
        self.sounds[name]        = pygame.mixer.Sound(path)
        
        oldTotal = self.total
        self.total += channels
        pygame.mixer.set_num_channels(self.total)
        
        q = []
        for i in range(channels):
            q.append(pygame.mixer.Channel(oldTotal + i))
           
        self.queue[name] = q

    def play(self, name, loop = 0):
        if(self.sounds.has_key(name)):
            sound    = self.sounds[name]
            q        = self.queue[name]
            channel  = q.pop()
            channel.play(sound, loop)
            q.append(channel)
                
    def volume(self, name, level):
        if(self.sounds.has_key(name)):
            self.sounds[name].set_volume(level)
        