from engine.pyEng    import *
from engine.entity   import *
from engine.obb      import *
from math            import *

class Ent(Entity):
    
    def __init__(self, id):
        Entity.__init__(self)
        
        self.id        = id
        self.name      = "ENTITY_" + str(self.id)
        self.screen    = engine.get("ScreenDevice")
        self.sound     = engine.get("SoundDevice")
        self.startTime = 0
        self.radius    = 0
        self.lat       = 0
        
    def collided(self, e):
        pass
        
    def checkCollisions(self):
        for key, value in engine.gameObjects.items():
            if(value.category == 'Entity'):
                if(not(value.name == self.name)):
                    dist = ((self.pos.x-value.pos.x)**2 + (self.pos.y-value.pos.y)**2)**0.5
                    rad  = self.radius + value.radius
                    if(dist < rad):
                        self.collided(value)
                        
    def move(self):
        if(not(engine.stop)):
            s = self.desSpeed - self.speed
            if(s > self.acel):
                s = self.acel
            if(s < -self.acel):
                s = -self.acel
            self.speed += s
            if(self.speed > self.maxSpeed):
                self.speed = self.maxSpeed
            if(self.speed < 0):
                self.speed = 0
            
            x = (self.pos.x + (100 * cos(self.desRot))) - self.pos.x
            y = (self.pos.y + (100 * sin(self.desRot))) - self.pos.y
            r = math.atan2(y, x) - self.rot
    
            while(r > pi):
                r -= 2 * pi
            while(r < -pi):
                r += 2 * pi
    
            if(r > self.rcel):
                r = self.rcel
            if(r < -self.rcel):
                r = -self.rcel
            self.rot += r
                
            self.pos.x += self.speed * cos(self.rot+self.lat)
            self.pos.y += self.speed * sin(self.rot+self.lat)