from engine.pyEng    import *
from ent             import *
from math            import *
import pygame
import random

class Explosion(Ent):
    
    def __init__(self):
        Ent.__init__(self, engine.getId())
        
        self.name    = "EXPLOSION_" + str(self.id)
        self.pos.x   = 500
        self.pos.y   = 500
        self.exRad   = 500
        self.exTime  = 0
        self.exDur   = 0.1
        self.exCount = 10
        self.exSize  = 250
        self.z       = 5
        
    def tick (self, time, dtime):
        
        self.exTime += dtime
        
        if(self.exTime > self.exDur):
            self.dead = True
        else:
            for i in range(self.exCount):
                d = self.exRad * self.exTime * random.random()
                r = 2 *pi * random.random()
                
                x = self.pos.x + (d * cos(r))
                y = self.pos.y + (d * sin(r))
                
                size  = self.exSize * self.exTime * random.random()
                color = 255 * random.random()
                
                self.screen.drawCircle([x, y], size, [255, color, 0], self.z)