from engine.pyEng    import *
from ent             import *
from drone1          import *
from drone2          import *
from explosion       import *
from math            import *
import random

smallRing = []
bigRing   = []

def createRings():
    ringLenth = 7.0, 7.0, 50.0
    ringRot   = 45.0, -45.0, 0.0
    
    for i in range(361):
        sring = []
        bring = []
        rot   = i * (pi/180)

        for j in range(12):
            r = j*pi/6
            tri = []
            for k in range(3):
                x = ringLenth[k] * cos(rot + ringRot[k] + r)
                y = ringLenth[k] * sin(rot + ringRot[k] + r)
                tri.append([x, y])
            sring.append(tri)
        smallRing.append(sring)
            
        for j in range(6):
            r = j*pi/3
            tri = []
            for k in range(3):
                x = ringLenth[k] * 1.25 * cos(rot + ringRot[k] + r)
                y = ringLenth[k] * 1.25 * sin(rot + ringRot[k] + r)
                tri.append([x, y])
            bring.append(tri)
        bigRing.append(bring)
        
createRings()
        
class Goal(Ent):
    
    def __init__(self):
        Ent.__init__(self, engine.getId())
        
        self.name = "GOAL_" + str(self.id)
        self.pos.x     = 500
        self.pos.y     = 500
        self.rot       = 0
        self.rot2      = 0 
        self.color     = engine.globalVar['goalColor']
        self.z         = 1
        self.radius    = 35
        self.timeVal   = 25.0
        self.timeR     = self.timeVal
        self.br        = 360/150
        self.sr        = 360/300
        self.fullLife  = 6
        self.life      = self.fullLife
        
    def tick (self, time, dtime):
        self.checkCollisions()
        
        self.rot += self.br
        if(self.rot > 360):
            self.rot = 0
        self.rot2 -= self.sr
        if(self.rot2 < 0):
            self.rot2 = 360
        
        if(not(engine.stop)):
            self.timeR -= dtime
            if(self.timeR < 0):
                p = engine.get('PLAYER_0')
                self.pos.x = p.pos.x + ((p.goalDist/2) - (p.goalDist * random.random()))
                self.pos.y = p.pos.y + ((p.goalDist/2) - (p.goalDist * random.random()))
                self.life = self.fullLife
                self.timeR = self.timeVal
                self.sound.play('warp')
            t = engine.get('TARGET_COUNTER')
            t.spawnTimer -= dtime
            if(t.spawnTimer < 0):
                t.spawnTimer = t.spawnRate
                if(t.targetCount < t.maxTargets):
                    t.targetCount += 1
                    d = Drone1()
                    rot  = 2 * math.pi * random.random()
                    dist = 200 + (200 * random.random())
                    
                    d.pos.x = self.pos.x + (dist * math.cos(rot))
                    d.pos.y = self.pos.y + (dist * math.sin(rot))
                    d.rot   = 2 * math.pi * random.random()
                    engine.add(d)

        self.drawEntity()
        
    def collided(self, e):
        if(e.name.find("BULLET") > -1):
            self.life -= 1
            e.dead    = True
            
            x = Explosion()
            x.pos.x = self.pos.x
            x.pos.y = self.pos.y
            engine.add(x)
            self.sound.play('sExp')

            if(self.life < 0):
                self.dead = True
                e.dead    = True
                p = engine.get('PLAYER_0')
                p.hitGoal()
                x = Explosion()
                x.exRad  = 1000
                x.exSize = 500
                x.exDur  = .25
                x.pos.x  = self.pos.x
                x.pos.y  = self.pos.y
                engine.add(x)
                self.sound.play('lExp')
            
    def drawEntity(self):
        self.screen.drawCircle(self.pos.val(), 30, self.color, self.z+1)
        self.screen.drawCircle(self.pos.val(), 27, [0,0,0],    self.z+3)
        
        for i in smallRing[int(self.rot)]:
            p = []
            for j in i:
                p.append([j[0]+self.pos.x, j[1]+self.pos.y])
            self.screen.drawPoly(p, self.color, self.z+2)
            
        for i in range(self.life):
            o = bigRing[int(self.rot2)][i]
            p = []
            for j in o:
                p.append([j[0]+self.pos.x, j[1]+self.pos.y])
            self.screen.drawPoly(p, self.color, self.z+2)