from engine.pyEng    import *
from ent             import * 
import math

radarTri = []

def buildRadar():
    radarLenth = 7.0, 7.0, 50.0
    radarRot   = 45.0, -45.0, 0.0
    
    for i in range(361):
        radar  = []
        rot    = i * (pi/180)
        
        tri = []
        for j in range(3):
            x = radarLenth[j] * 1.25 * cos(rot + radarRot[j])
            y = radarLenth[j] * 1.25 * sin(rot + radarRot[j])
            tri.append([x, y])
        radar.append(tri)
        
        radarTri.append(radar)

buildRadar()

class GoalRadar(Ent):
    
    def __init__(self, id):
        Ent.__init__(self, id)
        
        self.name = "GOALRADAR_" + str(id)
        self.pos.x     = 500
        self.pos.y     = 500
        self.rot       = 0
        self.rot2      = 0 
        self.color     = [0, 75, 0]
        self.z         = 1
        self.radius    = 35
        self.target    = 0
        
    def tick (self, time, dtime):
        self.rot = math.atan2(self.target.pos.y - self.pos.y, self.target.pos.x - self.pos.x)
        self.drawEntity()
            
    def drawEntity(self):
        self.screen.drawCircle(self.pos.val(), 30, self.color, self.z+1)
        self.screen.drawCircle(self.pos.val(), 27, [0,0,0],    self.z+3)
        
        r = self.rot
        while(r > pi):
            r -= 2 * pi
        while(r < -pi):
            r += 2 * pi
        r = int(r * (180.0/math.pi))
        
        for i in radarTri[r]:
            p = []
            for j in i:
                p.append([j[0]+self.pos.x, j[1]+self.pos.y])
            self.screen.drawPoly(p, self.color, self.z+3)