from engine.pyEng    import *
from ent             import *
from bullet          import *
from goal            import *
from superGoal       import *
from goalRadar       import *
from math            import *
import pygame
import random

playerTri    = []
playerShield = []

def buildPlayer():
    playerLenth = 7.0, 7.0, 25.0
    playerRot   = 45.0, -45.0, 0.0
    
    for i in range(361):
        player = []
        rot    = i * (pi/180)
        
        tri = []
        for j in range(3):
            x = playerLenth[j] * cos(rot + playerRot[j])
            y = playerLenth[j] * sin(rot + playerRot[j])
            tri.append([x, y])
        player.append(tri)
        
        tri = []
        for j in range(3):
            x = (playerLenth[j]/1.8) * cos(rot + playerRot[j] + (pi/5))
            y = (playerLenth[j]/1.8) * sin(rot + playerRot[j] + (pi/5))
            tri.append([x, y])
        player.append(tri)
        
        tri = []
        for j in range(3):
            x = (playerLenth[j]/1.5) * cos(rot + playerRot[j] + (pi/3))
            y = (playerLenth[j]/1.5) * sin(rot + playerRot[j] + (pi/3))
            tri.append([x, y])
        player.append(tri)
        
        tri = []
        for j in range(3):
            x = (playerLenth[j]/1.8) * cos(rot + playerRot[j] - (pi/5))
            y = (playerLenth[j]/1.8) * sin(rot + playerRot[j] - (pi/5))
            tri.append([x, y])
        player.append(tri)
        
        tri = []
        for j in range(3):
            x = (playerLenth[j]/1.5) * cos(rot + playerRot[j] - (pi/3))
            y = (playerLenth[j]/1.5) * sin(rot + playerRot[j] - (pi/3))
            tri.append([x, y])
        player.append(tri)
        
        playerTri.append(player)

def buildShield():
    
    shield = []
    for i in range(10):
        s = []
        for j in range(5):
            p = []
            
            r = (j * ((2*math.pi)/5)) + (i*((2*math.pi)/50))
            d = 50
            p.append(d * math.cos(r))
            p.append(d * math.sin(r))
            p.append(5)
            
            s.append(p)
        shield.append(s)
    playerShield.append(shield)
    
    shield = []
    for i in range(10):
        s = []
        for j in range(5):
            p = []
            
            r = (j * ((2*math.pi)/5)) + (i*((2*math.pi)/50))
            d = 55
            p.append(d * math.cos(r))
            p.append(d * math.sin(r))
            p.append(5)
            
            s.append(p)
        shield.append(s)
    playerShield.append(shield)
    
    shield = []
    for i in range(10):
        s = []
        for j in range(5):
            p = []
            
            r = (j * ((2*math.pi)/5)) + (i*((2*math.pi)/50))
            d = 60
            p.append(d * math.cos(r))
            p.append(d * math.sin(r))
            p.append(5)
            
            s.append(p)
        shield.append(s)
    playerShield.append(shield)
    
buildPlayer()
buildShield()

class PlayerEnt(Ent):
    
    def __init__(self, id):
        Ent.__init__(self, id)
        
        self.name      = "PLAYER_" + str(id)
        self.joy       = engine.get("Gamepad_" + str(id))
        self.pos.x     = 500
        self.pos.y     = 500
        self.rot       = pi/2
        self.maxSpeed  = 3
        self.acel      = 0.025
        self.rcel      = 0.05
        self.color     = [0, 0, 255]
        self.z         = 20
        self.fireDist  = 15
        self.fireCount = 20
        self.fireDir   = 0
        self.fireTime  = 0
        self.fireRate  = 0.1
        
        self.goal = Goal()
        self.goal.pos.x = 100
        self.goal.pos.y = 100
        engine.add(self.goal)

        self.radar = GoalRadar(0)
        engine.add(self.radar)
        
        self.radar.target = self.goal
        
        self.score    = 0
        self.goalDist = 5000
        
        self.radius      = 15
        self.life        = 5
        self.shield      = 1
        self.shieldCount = 0
        self.flashCount  = 0
        
        self.screen.camera[0] = self.pos.x
        self.screen.camera[1] = self.pos.y
        #self.sound.play('engine', -1)
        
        self.boss      = False
        self.levelUp   = False
        self.levelWait = False
        self.levelTime = 0
        self.levelWaitTime = 10
        
    def hitGoal(self):
        engine.globalVar['baseKills'] += 1
        self.setLevel(engine.globalVar['baseKills'])
        
        self.score       += 100
        if(self.boss):
            self.goal = SuperGoal()
            self.boss = False
        else:
            self.goal = Goal()
        self.goal.pos.x   = self.pos.x + ((self.goalDist/2) - (self.goalDist * random.random()))
        self.goal.pos.y   = self.pos.y + ((self.goalDist/2) - (self.goalDist * random.random()))
        self.radar.target = self.goal
        engine.add(self.goal)

    def hitTarget(self, score = 1):
        self.score += score
        
    def tick (self, time, dtime):
        
        if(self.levelUp):
            self.levelUp   = False
            self.levelWait = True
            self.levelTime = self.levelWaitTime
            engine.stop = True
            
            for key, value in engine.gameObjects.items():
                if(value.category == 'Entity'):
                    if(not(value.name.find("PLAYER") > -1)):
                        if(not(value.name.find("GOAL") > -1)):
                            value.dead = True
            t = engine.get('TARGET_COUNTER')
            t.targetCount = 0
            
        if(self.levelWait):
            
            self.screen.drawText([380, 300], 'Level Up', 70, [25, 25, 255])
            self.screen.drawText([385, 400], 'Continue In', 50, [255, 255, 255])
            self.screen.drawText([455, 450], str(round(self.levelTime, 2)), 50, [255, 255, 255])
        
            self.levelTime -= dtime
            if(self.levelTime < 0):
                self.levelWait  = False
                engine.stop = False
        
        k = pygame.key.get_pressed()
        
        if(not(engine.stop)):
            if(self.joy.button(0) or (k[K_SPACE])):
                if(time > (self.fireTime + self.fireRate)):
                    self.fireTime = time
                    b = Bullet()
                    b.desRot = self.rot
                    b.rot    = self.rot
                    b.pos.x  = self.pos.x + (25 * math.cos(self.rot))
                    b.pos.y  = self.pos.y + (25 * math.sin(self.rot))
                    b.startTime = time
                    engine.add(b)
                    self.sound.play('weapon')
        
        self.desSpeed = self.maxSpeed

        a = math.atan2(self.joy.yAxis(0), self.joy.xAxis(0))
        if((a > -(math.pi/2)) and (a < (math.pi/2))):
            self.desRot = self.rot + (abs(self.joy.xAxis(0))**0.5 * self.rcel)
        else:
            self.desRot = self.rot - (abs(self.joy.xAxis(0))**0.5 * self.rcel)
        
        if(self.joy.button(4) and self.joy.button(5)):
            self.lat = pi
            self.fireDir = 0
        elif(self.joy.button(4)):
            self.lat = -pi/2
            self.fireDir = pi/2
        elif(self.joy.button(5)):
            self.lat = pi/2
            self.fireDir = -pi/2
        else:
            self.lat = 0
            self.fireDir = pi
            
        if(k[K_e]):
            self.desRot = self.rot + self.rcel
        if(k[K_q]):
            self.desRot = self.rot - self.rcel
            
        if(k[K_s]):
            self.lat = pi
            self.fireDir = 0
        elif(k[K_a]):
            self.lat = -pi/2
            self.fireDir = pi/2
        elif(k[K_d]):
            self.lat = pi/2
            self.fireDir = -pi/2
        else:
            self.lat = 0
            self.fireDir = pi
        
        self.sound.volume('engine', self.desSpeed/self.maxSpeed)
        
        self.move()
        self.checkCollisions()
        self.drawEntity()
        
        self.screen.pushMove(self.pos.x, self.pos.y)
        self.radar.pos.x = self.pos.x
        self.radar.pos.y = self.pos.y
        
        self.screen.drawText([50, 30], "Level : " + str(engine.globalVar['level']), 24, [255, 255, 255])
        self.screen.drawText([50, 50], "Score : " + str(self.score), 24, [255, 255, 255])
        self.screen.drawText([50, 70], "Life  : " + str(self.life), 24, [255, 255, 255])
        self.screen.drawText([50, 90], "Shield: " + str(self.shield), 24, [255, 255, 255])
        if(not(engine.stop)):
            self.screen.drawText([850, 30], "D - " + str(int(self.pos-self.radar.target.pos)), 24, [255, 255, 255])
            self.screen.drawText([850, 50], "T - " + str(int(self.radar.target.timeR)), 24, [255, 255, 255])
        else:
            self.screen.drawText([850, 30], "D - " , 24, [255, 255, 255])
            self.screen.drawText([850, 50], "T - " , 24, [255, 255, 255])
        
        if(self.flashCount > 0):
            if(self.flashCount%2):
                self.screen.drawCircle(self.pos.val(), 50, [255, 0, 0], self.z-1)
            self.flashCount -= 1
        
    def collided(self, e):
        if(e.name.find("DRONE1") > -1):
            e.die()
            
            if(self.shield > 0):
                self.shield -= 1
            else:
                self.life   -= 1
            self.flashCount = 30
        elif(e.name.find("SHIELDPOWER") > -1):
            e.dead = True
            if(self.shield < 3):
                self.shield += 1
            self.score += 10
            
    def drawEntity(self):
        self.screen.drawCircle(self.pos.val(), 9, self.color, self.z+1)
        self.screen.drawCircle(self.pos.val(), 7, [0,0,0],    self.z+2)
        
        r = self.rot
        while(r > pi):
            r -= 2 * pi
        while(r < -pi):
            r += 2 * pi
        r = int(r * (180.0/math.pi))
        
        for i in playerTri[r]:
            p = []
            for j in i:
                p.append([j[0]+self.pos.x, j[1]+self.pos.y])
            self.screen.drawPoly(p, self.color, self.z+3)
            
        fireX = self.pos.x
        fireY = self.pos.y
        for i in range(self.fireCount):
            
            dir   = 2 * pi * random.random()
            dist1 = 7 * self.desSpeed * random.random()
            dist2 = 1.5  * self.desSpeed * random.random()

            x  = fireX + (self.fireDist * cos(self.rot+self.fireDir))
            y  = fireY + (self.fireDist * sin(self.rot+self.fireDir))
            x += dist1 * math.cos(self.rot+self.fireDir)
            y += dist1 * math.sin(self.rot+self.fireDir)
            x += dist2 * self.desSpeed * cos(dir)
            y += dist2 * self.desSpeed * sin(dir)
            size  = self.desSpeed * 4 * random.random()
            color = 255 * random.random()
            self.screen.drawCircle([x, y], size, [255, color, 0], self.z)
        
        self.shieldCount += 1
        if(self.shieldCount > 9):
            self.shieldCount = 0
        
        for i in range(self.shield):
            if(i == 0):
                c = [150,0, 0]
            if(i == 1):
                c = [0, 150,0]
            if(i == 2):
                c = [0, 0, 150]
            for j in playerShield[i][self.shieldCount]:
                self.screen.drawCircle([j[0]+self.pos.x, j[1]+self.pos.y], j[2], c, self.z)
                
    def setLevel(self, kills):
        if(kills == 2):
            self.boss = True
        elif(kills == 5):
            self.boss = True
        elif(kills == 8):
            self.boss = True
        elif(kills == 11):
            self.boss = True
        elif(kills == 14):
            self.boss = True
        elif(kills == 17):
            self.boss = True
        elif(kills == 20):
            self.boss = True
        
        if(kills == 3):
            self.levelUp = True
            engine.globalVar['level']       = 2
            engine.globalVar['drone1Speed'] = 3.3
            engine.globalVar['goalColor']   = [50, 250, 50]
            t = engine.get('TARGET_COUNTER')
            t.spawnRate   = .9
        elif(kills == 6):
            self.levelUp = True
            engine.globalVar['level']       = 3
            engine.globalVar['drone1Speed'] = 3.4
            engine.globalVar['goalColor']   = [50, 50, 250]
            t = engine.get('TARGET_COUNTER')
            t.spawnRate   = .8
        elif(kills == 9):
            self.levelUp = True
            engine.globalVar['level']       = 4
            engine.globalVar['drone1Speed'] = 3.5
            engine.globalVar['goalColor']   = [250, 50, 50]
            t = engine.get('TARGET_COUNTER')
            t.spawnRate   = .7
        elif(kills == 12):
            self.levelUp = True
            engine.globalVar['level']       = 5
            engine.globalVar['drone1Speed'] = 3.6
            engine.globalVar['goalColor']   = [250, 50, 250]
            t = engine.get('TARGET_COUNTER')
            t.spawnRate   = .6
        elif(kills == 15):
            self.levelUp = True
            engine.globalVar['level']       = 6
            engine.globalVar['drone1Speed'] = 3.7
            engine.globalVar['goalColor']   = [50, 250, 250]
            t = engine.get('TARGET_COUNTER')
            t.spawnRate   = .5
        elif(kills == 18):
            self.levelUp = True
            engine.globalVar['level']       = 7
            engine.globalVar['drone1Speed'] = 3.8
            engine.globalVar['goalColor']   = [50, 250, 50]
            t = engine.get('TARGET_COUNTER')
            t.spawnRate   = .4
        elif(kills == 21):
            self.levelUp = True
            engine.globalVar['level']       = 8
            engine.globalVar['drone1Speed'] = 3.9
            engine.globalVar['goalColor']   = [50, 50, 250]
            t = engine.get('TARGET_COUNTER')
            t.spawnRate   = .3