from engine.pyEng          import *
from engine.screenDevice   import *
from engine.soundDevice    import *
from engine.keyboardDevice import *
from engine.gamepadDevice  import *
from playerEnt             import *
from drone1                import *
from goal                  import *
from goalRadar             import *
from background            import *
from targetCounter         import *

engine.stop = True
def setGlobalVar():
    engine.globalVar['level']       = 1
    engine.globalVar['drone1Speed'] = 3.2
    engine.globalVar['baseKills']   = 0
    engine.globalVar['goalColor']   = [250, 150, 0]
setGlobalVar()

screen = ScreenDevice()
screen.configure(1000, 1000, "Talon Blue")
engine.add(screen)

sound = SoundDevice()
engine.add(sound)
sound.add('sExp'  , 'sounds/exp1.wav'    , 5)
sound.volume('sExp', 0.5)
sound.add('lExp'  , 'sounds/exp0.wav'    , 2)
sound.volume('lExp', 0.5)
sound.add('engine', 'sounds/engines.wav')
sound.add('weapon', 'sounds/hweapon1.wav', 5)
sound.volume('weapon', 0.5)
sound.add('warp', 'sounds/warp.wav')
sound.volume('warp', 0.5)

sound.add('back'  , 'sounds/gra3mb.wav')
sound.volume('back', 0.5)
sound.play('back', -1)

gamepad1 = GamepadDevice(0)
engine.add(gamepad1)

player1 = PlayerEnt(0)
engine.add(player1)

counter = TargetCounter()
engine.add(counter)

back = Background()
engine.add(back)

engine.list()

state       = 0
bucket      = 0
playerScore = 0
score       = 0
newScore    = False
scoreIndex  = 0

while(True):
    engine.tick()
    
    if(state == 0):
        screen.drawText([380, 300], 'Talon Blue', 70, [25, 25, 255])
        screen.drawText([300, 375], 'Press any Button to Start', 50, [255, 255, 255])

        if(bucket < 50):
            switch = True
            for i in range(gamepad1.numButtons()):
                if(gamepad1.button(i)):
                    switch = False
            if(switch):
                bucket += 1
       
        next = False
        if(bucket > 30):
            for i in range(gamepad1.numButtons()):
                if(gamepad1.button(i)):
                    next = True
            if(engine.keyPressed):
                next = True
        
        if(next):
            state = 1
            engine.stop = False
    elif(state == 1):
        if(player1.life <= 0):
            state = 2
            bucket = 0
            engine.stop = True
            playerScore = player1.score
    elif(state == 2):
        screen.drawText([300, 350], "Game Over", 100, [255, 255, 255])
        
        if(bucket < 50):
            switch = True
            for i in range(gamepad1.numButtons()):
                if(gamepad1.button(i)):
                    switch = False
            if(switch):
                bucket += 1
       
        next = False
        if(bucket > 30):
            for i in range(gamepad1.numButtons()):
                if(gamepad1.button(i)):
                    next = True
        
        if(next):
            state = 3
    elif(state == 3):
        state  = 4
        bucket = 0
        
        f = open('config/highScore.txt', 'r')
        s = []
        for i in f:
            j = i.split()
            s.append([j[0], int(j[1])])
        f.close()
        
        score    = []
        newScore = False
        offset   = 0
        for i in range(25):
            e = ['None', 0]
            if(i < len(s)):
                e = s[i-offset]
            
            if(newScore is False):
                if(playerScore > e[1]):
                    newScore   = True
                    scoreIndex = i
                    offset = 1
                    e = ['', playerScore]
            score.append(e)
    elif(state == 4):
        screen.drawText([320, 150], "High Scores", 100, [255, 255, 255])
        
        if(newScore):
            if(engine.left):
                l = len(score[scoreIndex][0])
                if(( l == 0 ) or ( l == 1 )):
                    score[scoreIndex][0] = ''
                else:
                    s = ''
                    for i in range(l - 1):
                        s += score[scoreIndex][0][i]
                    score[scoreIndex][0] = s
            if(engine.keyPressed):
                    score[scoreIndex][0] += engine.keys[0]
        
        for i, o in enumerate(score):
            if((newScore) and (i == scoreIndex)):
                screen.drawText([400, 250 + (i*25)], str(i+1) + ':', 30, [255,   0,   0])
                screen.drawText([450, 250 + (i*25)], o[0],           30, [255,   0,   0])
                screen.drawText([650, 250 + (i*25)], str(o[1]),      30, [255,   0,   0])
            else:
                screen.drawText([400, 250 + (i*25)], str(i+1) + ':', 25, [255, 255, 255])
                screen.drawText([450, 250 + (i*25)], o[0],           25, [255, 255, 255])
                screen.drawText([650, 250 + (i*25)], str(o[1]),      25, [255, 255, 255])
                
        if(bucket < 50):
            switch = True
            for i in range(gamepad1.numButtons()):
                if(gamepad1.button(i)):
                    switch = False
            if(switch):
                bucket += 1
       
        next = False
        if(bucket > 30):
            if(engine.enter):
                next = True
            
            for i in range(gamepad1.numButtons()):
                if(gamepad1.button(i)):
                    next = True
                    
        if(next):
            f = open('config/highScore.txt', 'w')
            for i in score:
                if(i[0] == ''):
                    c = 'Anon' + ' ' + str(i[1]) + '\n'
                else:
                    c = i[0] + ' ' + str(i[1]) + '\n'
                f.write(c)
            f.close()
            state  = 0
            bucket = 0
            
            engine.clear()
            setGlobalVar()
            
            engine.add(screen)
            engine.add(sound)
            engine.add(gamepad1)
            engine.add(back)
            
            player1 = PlayerEnt(0)
            engine.add(player1)
    
            counter = TargetCounter()
            engine.add(counter)